SLASH_SHAMANSTRIKEWHEN1 = "/ssw"
SLASH_SHAMANSTRIKEWHEN2 = "/shamanstrikewhen"
local settingMode = false

local playerGUID = UnitGUID("player")
local firstWf = false
local parentframe = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
local frame = CreateFrame("Frame", nil, parentframe)
local wfCooldown = CreateFrame("Cooldown", "wfCooldown", frame, "CooldownFrameTemplate")
parentframe:SetSize(70, 70)
parentframe:SetPoint("CENTER", 0, -120)
frame:SetAllPoints()
frame.texture = frame:CreateTexture(nil, "BACKGROUND")
frame.texture:SetPoint("CENTER")
frame.texture:SetAllPoints()
wfCooldown:SetAllPoints()

local function settings(cmd)  
  frame.texture:SetTexture(GetSpellTexture("Stormstrike"))
  if settingMode then
    parentframe:EnableMouse(false)
    parentframe:SetResizable(false)
    parentframe:SetMovable(false)
    parentframe:SetBackdrop(nil)
    settingMode = false
    parentframe:Hide()
  else
    settingMode = true
    parentframe:Show()
    backdropInfo = {
      bgFile = "Interface/Buttons/WHITE8X8",
      edgeFile = "Interface/Buttons/WHITE8X8",
      edgeSize = 1,
    insets = { left = 1, right = 1, top = 1, bottom = 1, },
  }
    parentframe:SetBackdrop(backdropInfo)
    parentframe:SetBackdropColor(0,0,0,1) -- Black background
    parentframe:SetBackdropBorderColor(1,1,1,1) -- White border
    parentframe:RegisterForDrag("LeftButton")
    parentframe:EnableMouse(true)
    parentframe:SetResizable(true)
    parentframe:SetMovable(true)
    parentframe:SetMinResize(10,10) -- The minimum height & width the frame can be resized
    parentframe:SetMaxResize(500,500) -- The maximum height & width the frame can be resized
  end
end
SlashCmdList["SHAMANSTRIKEWHEN"] = settings

local function OnUpdate(self, elapsed)
    local start, duration, enabled, modRate = GetSpellCooldown("Stormstrike")
  if duration <= 2 then
    frame:Show()
  else
    frame:Hide()
  end
end

local function OnEvent(self, event)
  local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool = CombatLogGetCurrentEventInfo()
  if event == "PLAYER_REGEN_DISABLED" then
    parentframe:Show()
    frame.texture:SetTexture(GetSpellTexture("Stormstrike"))
  end
  if event == "PLAYER_REGEN_ENABLED" then
    parentframe:Hide()
  end
  if event == "COMBAT_LOG_EVENT_UNFILTERED" then
    if spellName == "Windfury Attack" and sourceGUID == playerGUID then
      if firstWf then
        wfCooldown:SetCooldown(GetTime(),3)
        firstWf = false
      else
        firstWf = true
      end
    end
  end
end

frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:RegisterEvent("SPELL_UPDATE_COOLDOWN")
frame:SetScript("OnEvent", OnEvent)
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
parentframe:SetScript("OnUpdate", OnUpdate)
parentframe:SetScript("OnMouseDown", function(self, button)
  if IsShiftKeyDown() then
    self:StartMoving()
  else
  self:StartSizing()
  end
  self.isMoving = true
  self.hasMoved = false
end)
parentframe:SetScript("OnMouseUp", function(self)
  if self.isMoving then
    self:StopMovingOrSizing()
    self.isMoving = false
    self.hasMoved = true
  end
end)
parentframe:Hide()
